﻿using AbstractSoftwareInstallationContracts.BindingModels;
using AbstractSoftwareInstallationContracts.ViewModels;
using AbstractSoftwareInstallationDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AbstractSoftwareInstallationDatabaseImplement.Models
{
    public class Software : ISoftwareModel
    {
        public int Id { get; private set; }
        [Required]
        public string SoftwareName { get; private set; } = String.Empty;
        [Required]
        public double Cost { get; set; }
        [ForeignKey("SoftwareId")]
        public virtual List<PackageSoftware> PackageSoftwares { get; set; } = new();
        public static Software? Create(SoftwareBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Software()
            {
                Id = model.Id,
                SoftwareName = model.SoftwareName,
                Cost = model.Cost
            };
        }
        public void Update(SoftwareBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            SoftwareName = model.SoftwareName;
            Cost = model.Cost;
        }
        public SoftwareViewModel GetViewModel => new()
        {
            Id = Id,
            SoftwareName = SoftwareName,
            Cost = Cost
        };

    }
}
