﻿using AbstractSoftwareInstallationContracts.BindingModels;
using AbstractSoftwareInstallationContracts.ViewModels;
using AbstractSoftwareInstallationDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AbstractSoftwareInstallationListImplement.Models
{
    public class Package : IPackageModel
    {
        public string PackageName { get; private set; } = string.Empty;

        public double Price { get; set; }

        public Dictionary<int, (ISoftwareModel, int)> PackageSoftware { get; private set; } = new Dictionary<int, (ISoftwareModel, int)>();

        public int Id { get; private set; }
        public static Package? Create(PackageBindingModel? model)
        {
            if (model == null) return null;
            return new Package
            {
                Id = model.Id,
                PackageName = model.PackageName,
                Price = model.Price,
                PackageSoftware = model.PackageSoftware
            };
        }
        public void Update(PackageBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            PackageName = model.PackageName;
            Price = model.Price;
            PackageSoftware = model.PackageSoftware;
        }
        public PackageViewModel GetViewModel => new()
        {
            Id = Id,
            PackageName = PackageName,
            Price = Price,
            PackageSoftware = PackageSoftware
        };
    }
}
