﻿using AbstractSoftwareInstallationContracts.BindingModels;
using AbstractSoftwareInstallationContracts.ViewModels;
using AbstractSoftwareInstallationDataModels.Models;

namespace AbstractSoftwareInstallationListImplement.Models
{
    public class Software : ISoftwareModel
    {
        public string SoftwareName { get; private set; } = String.Empty;

        public double Cost { get; set; }

        public int Id { get; private set; }
        public static Software? Create(SoftwareBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Software()
            {
                Id = model.Id,
                SoftwareName = model.SoftwareName,
                Cost = model.Cost
            };
        }
        public void Update(SoftwareBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            SoftwareName = model.SoftwareName;
            Cost = model.Cost;
        }
        public SoftwareViewModel GetViewModel => new()
        {
            Id = Id,
            SoftwareName = SoftwareName,
            Cost = Cost
        };
    }
}